/*
 * TestStubMessageSender.java
 *
 * Created on 18. leden 2007, 9:43
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.novoj.emt;

import cz.novoj.emt.exceptions.SendException;
import static org.junit.Assert.*;

/**
 * Test stub for message sender.
 * @author Rodina Novotnych
 */
public class StubMessageSender implements IMessageSender {
    private String expectedReceiver;
    private String expectedSender;
    private String expectedSubject;
    private String expectedBody;
    private String actualReceiver;
    private String actualSender;
    private String actualSubject;
    private String actualBody;
    int callCounter = 0;
    
    /** Creates a new instance of TestStubMessageSender */
    public StubMessageSender(String receiver, String sender, String subject, String body) {
        this.expectedReceiver = receiver;
        this.expectedSender = sender;
        this.expectedSubject = subject;
        this.expectedBody = body;
    }
    
    public void send(String receiver, String sender, String subject, String body) throws SendException {
        this.actualReceiver = receiver;
        this.actualSender = sender;
        this.actualSubject = subject;
        this.actualBody = body;
        callCounter++;
    }
    
    public void verifyCalls(int expectedCallCount) throws AssertionError {
        if (expectedCallCount != callCounter) throw new AssertionError("Expected number of calls is " + expectedCallCount + " but method was called " + callCounter + "!");
        assertEquals(expectedReceiver, actualReceiver);
        assertEquals(expectedSender, actualSender);
        assertEquals(expectedSubject, actualSubject);
        assertEquals(expectedBody, actualBody);
    }

}
